﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8.78
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim consent As ConsentManager

End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
'	راهنمایی در این صفحه از سایت اصلی
'	https://www.b4x.com/android/forum/threads/firebaseadmob-and-user-consent.93347/

'	consent.AddTestDevice("D4AC977CA12D122C4563730CC762C302")
'	consent.SetDebugGeography(True) 'comment for regular operation 'True = EU, False = Non-EU

	consent.Initialize("consent")
	consent.RequestInfoUpdate(Array(CodeModule.Publisher_ID))

	Wait For consent_InfoUpdated (Success As Boolean)
	If Success = False Then
		Log($"Error getting consent state: ${LastException}"$)
	End If
	Log($"Consent state: ${consent.ConsentState}"$)
	Log("EU: " & consent.IsRequestLocationInEeaOrUnknown)
	
	'''اسم اکتیوتی رو در هر 2 خط دقت کنید
'	Do While IsPaused(Activity_RewardedVideo)
'		Sleep(100)
'	Loop
'	CallSubDelayed(Activity_RewardedVideo, "ConsentStateAvailable")
	
	'در آدرس زیر گفته برای بسته نشدن سرویس هست
	'https://www.b4x.com/android/forum/threads/intent-filters-intercepting-sms-messages-in-the-background.20103/
	Sleep(0) 'allow the MessageReceived event to be raised.
	Service.StopAutomaticForeground
End Sub

Sub Service_Start (StartingIntent As Intent)
	

End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
