﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	
	Private clv2 As CustomListView
	Private Label1 As B4XView
	Private CheckBox1 As B4XView
	
	Dim pAdmob1 As Panel
	Dim pAdmob2 As Panel
	Dim pAdmob3 As Panel
End Sub

Sub Activity_Create(FirstTime As Boolean)
	pAdmob1.Initialize("pAdmob1")
	pAdmob2.Initialize("pAdmob2")
	pAdmob3.Initialize("pAdmob3")
	pAdmob1.SetLayout(0, 0, 100%x, 100dip)
	pAdmob2.SetLayout(0, 0, 100%x, 100dip)
	pAdmob3.SetLayout(0, 0, 100%x, 100dip)
	
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("Layout_native_ad")
	For i = 1 To 18
		If i=5 Then
			clv2.Add(pAdmob1, -1)
			NativeAdviewPanel1("ca-app-pub-3940256099942544/2247696110")
		End If

		If i=10 Then
			clv2.Add(pAdmob2, -1)
			NativeAdviewPanel2("ca-app-pub-3940256099942544/2247696110")
		End If

		If i=15 Then
			clv2.Add(pAdmob3, -1)
			NativeAdviewPanel3("ca-app-pub-3940256099942544/2247696110")
		End If

		clv2.Add(CreateListItem($"Item #${i}"$, clv2.AsView.Width, 60dip), $"Item #${i}"$)
	Next
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
		
  '** NEW **		
Sub NativeAdviewPanel1(AdUnitId As String)
	Try
		Wait for (LoadUnifiedNativeAd(AdUnitId)) Complete (Result As Panel)
		If Result <> Null Then
			pAdmob1.RemoveAllViews
			pAdmob1.AddView(Result, 0, 0, 100%x, 100dip)
		End If
	Catch
		Log(LastException)
	End Try
End Sub

Sub NativeAdviewPanel2(AdUnitId As String)
	Try
		Wait for (LoadUnifiedNativeAd(AdUnitId)) Complete (Result As Panel)
		If Result <> Null Then
			pAdmob2.RemoveAllViews
			pAdmob2.AddView(Result, 0, 0, 100%x, 100dip)
		End If
	Catch
		Log(LastException)
	End Try
End Sub

Sub NativeAdviewPanel3(AdUnitId As String)
	Try
		Wait for (LoadUnifiedNativeAd(AdUnitId)) Complete (Result As Panel)
		If Result <> Null Then
			pAdmob3.RemoveAllViews
			pAdmob3.AddView(Result, 0, 0, 100%x, 100dip)
		End If
	Catch
		Log(LastException)
	End Try
End Sub

Sub LoadUnifiedNativeAd(idAd As String) As ResumableSub
	Dim AdUnitId As String = idAd
   
	Dim ctxt As JavaObject
	ctxt.InitializeContext
   
	Dim builder As JavaObject
	builder.InitializeNewInstance("com.google.android.gms.ads.AdLoader.Builder", Array(ctxt, AdUnitId))
   
	Dim onUnifiedAdLoadedListener As Object = builder.CreateEventFromUI("com/google/android/gms/ads/formats/UnifiedNativeAd.OnUnifiedNativeAdLoadedListener".Replace("/", "."), _
       "UnifiedAdLoaded", Null)
	builder.RunMethod("forUnifiedNativeAd", Array(onUnifiedAdLoadedListener))
	
	Dim Listener As JavaObject
	Listener.InitializeNewInstance(Application.PackageName & ".nativeactivity$MyAdListener", Array("UnifiedNativeAd"))  'change 'main' with the current activity module name
	builder.RunMethod("withAdListener", Array(Listener))
   
	Dim AdLoader As JavaObject = builder.RunMethod("build", Null)

	Dim AdRequestBuilder As JavaObject
	AdRequestBuilder.InitializeNewInstance("com/google/android/gms/ads/AdRequest.Builder".Replace("/", "."), Null)
	AdLoader.RunMethod("loadAd", Array(AdRequestBuilder.RunMethod("build", Null)))
	
	Wait For (builder) UnifiedAdLoaded_Event (MethodName As String, Args() As Object)
  
	Dim NativeUnifiedAd As JavaObject = Args(0)

	Dim NativeUnifiedAdView As JavaObject
	NativeUnifiedAdView.InitializeNewInstance("com/google/android/gms/ads/formats/UnifiedNativeAdView".Replace("/", "."), _
       Array(ctxt))
	   
	Dim pNativeAdView As Panel = NativeUnifiedAdView
   
	Dim content As Panel
	content.Initialize("")
	pNativeAdView.AddView(content, 0, 0, 100%x, 300dip)
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = NativeUnifiedAd.RunMethod("getHeadline", Null)
	content.AddView(lbl, 10dip, 10dip, 300dip, 50dip)
	NativeUnifiedAdView.RunMethod("setHeadlineView", Array(lbl))
	Dim lbl2 As Label
	lbl2.Initialize("")
	lbl2.Text = NativeUnifiedAd.RunMethod("getBody", Null)
	content.AddView(lbl2, 10dip, 60dip, 300dip, 50dip)
	NativeUnifiedAdView.RunMethod("setBodyView", Array(lbl2))
	
	Dim logo As JavaObject = NativeUnifiedAd.RunMethod("getIcon", Null)
	If logo.IsInitialized Then
		Dim logoView As Panel
		logoView.Initialize("")
		logoView.Background = logo.RunMethod("getDrawable", Null)
		content.AddView(logoView, 210dip, 0, 100dip, 100dip)
		NativeUnifiedAdView.RunMethod("setIconView", Array(logoView))
	End If
	
	Dim vid As JavaObject = NativeUnifiedAd.RunMethod("getVideoController", Null)

	If vid.IsInitialized Then
		Dim MediaView As JavaObject
		MediaView.InitializeNewInstance("com/google/android/gms/ads/formats/MediaView".Replace("/", "."), Array(ctxt))
		content.AddView(MediaView, 10dip, 60dip, 200dip, 200dip)
		NativeUnifiedAdView.RunMethod("setMediaView", Array(MediaView))
	Else
		'If don't has video, check if is there are images
		Dim images As List = NativeUnifiedAd.RunMethod("getImages", Null)
		If images.IsInitialized And images.Size > 0 Then
			Dim MediaView As JavaObject
			MediaView.InitializeNewInstance("com/google/android/gms/ads/formats/MediaView".Replace("/", "."), Array(ctxt))
			content.AddView(MediaView, 10dip, 60dip, 200dip, 200dip)
			NativeUnifiedAdView.RunMethod("setImageView", Array(MediaView))
		End If
	End If

	NativeUnifiedAdView.RunMethod("setNativeAd", Array(NativeUnifiedAd))
   
	Return pNativeAdView  '** NEW **
End Sub

Sub UnifiedNativeAd_FailedToReceiveAd (ErrorCode As String)
	Log("UnifiedNativeAd_FailedToReceiveAd: " & ErrorCode)
End Sub

Sub UnifiedNativeAd_AdOpened
	Log("UnifiedNativeAd_AdOpened")
End Sub

Sub UnifiedNativeAd_ReceiveAd
	Log("UnifiedNativeAd_ReceiveAd")
End Sub

#if Java
public static class MyAdListener extends com.google.android.gms.ads.AdListener {
   
   String eventName;
   public MyAdListener(String s) {
       eventName = s.toLowerCase(BA.cul);
   }
   @Override
   public void onAdClosed() {
       processBA.raiseEventFromDifferentThread(null, null, 0, eventName + "_adclosed", false, null);
   }
   @Override
   public void onAdFailedToLoad(int arg0) {
       processBA.raiseEventFromDifferentThread(null, null, 0, eventName + "_failedtoreceivead", false, new Object[] {String.valueOf(arg0)});
   }
   @Override
   public void onAdLeftApplication() {
       processBA.raiseEventFromDifferentThread(null, null, 0, eventName + "_adleftapplication", false, null);
   }
   @Override
   public void onAdOpened() {
       processBA.raiseEventFromDifferentThread(null, null, 0, eventName + "_adopened", false, null);
   }
   @Override
   public void onAdLoaded() {
       processBA.raiseEventFromDifferentThread(null, null, 0, eventName + "_receivead", false, null);
   }
}
#End If

Sub clv2_ItemClick(Index As Int, Value As Object)
	clv2.AsView.BringToFront
	Log(Index & " = " & Value)
	
End Sub
Sub CreateListItem(Text As String, Width As Int, Height As Int) As Panel
	Dim p As Panel
	p.Initialize("")
	p.SetLayout(0, 0, Width, Height)
	p.LoadLayout("CellItem")
	Label1.Text = Text
	Return p
End Sub
